<template>
	<div class="no-block-spacing">
		<SlicesRenderer v-bind="{ sliceComponents }">
			<template #default="{ slice, index }">
				<div
					v-if="slice && slice.sliceType === 'ThankYouMessage'"
					id="thank-you-message"
					:key="index"
					:class="$style.block"
					:style="{
						'--thank-you-message-max-width': slice.props.containerMaxWidth
							? `${slice.props.containerMaxWidth / 10}rem`
							: '48rem',
					}"
				>
					<div
						v-rich-content
						:class="$style.header"
						:style="{ '--heading-text-align': slice.props.headingTextAlignment || 'center' }"
						v-html="slice.props.heading"
					/>
					<div
						v-rich-content
						:class="$style.thanksCopy"
						:style="{ '--copy-text-align': slice.props.messageTextAlignment || 'center' }"
						v-html="slice.props.message"
					/>

					<div v-if="slice.props.ctaLink && slice.props.ctaLink.url" :class="$style.ctaSection">
						<BaseButton :smart="slice.props.ctaLink.url" size="medium" appearance="primary">
							{{ slice.props.ctaText }}
						</BaseButton>
					</div>
				</div>
			</template>
		</SlicesRenderer>
	</div>
</template>

<script>
import SlicesRenderer from '@components/slices-renderer';
import getMetadata from '@/utils/get-metadata';
import { loadComponentsBeforeRender, getSliceComponents } from '@/utils/async-components-helpers';

export default {
	components: {
		SlicesRenderer,
	},

	asyncData: async ({ store, req }) => {
		const page = await store.dispatch('pages/FETCH_PAGE_DATA', { pageName: 'nominate_a_small_business', req });

		await loadComponentsBeforeRender(page.afterSubmit);

		return { page };
	},

	head() {
		return this.page
			? getMetadata(
					{
						...this.page.seo,
						path: this.$route && this.$route.path,
					},
					this.$sentry
			  )
			: {};
	},

	computed: {
		sliceComponents() {
			return getSliceComponents(this.page.afterSubmit);
		},
	},
};
</script>

<style lang="scss" module>
@import '@design';

.header {
	max-width: var(--thank-you-message-max-width);
	text-align: var(--heading-text-align);

	h1 {
		@include use-text-style('heading-650');
	}

	h2 {
		@include use-text-style('heading-400');
	}

	h3,
	h4,
	h5,
	h6 {
		@include use-text-style('heading-200');
	}

	h1,
	h2,
	h3,
	h4,
	h5,
	h6 {
		margin: 0 auto 1em;
		font-weight: 300;
	}
}

.block {
	max-width: var(--thank-you-message-max-width);
	padding: 5rem size('s');
	margin: 0 auto;
	line-height: 1.85714;

	button,
	a {
		line-height: 1;
	}
}

.thanksCopy {
	@include use-text-style('type-500');

	font-weight: 300;
	text-align: var(--copy-text-align);

	/* linter doesn't like specificity here */
	/* stylelint-disable */
	p:not(:last-of-type) {
		margin-bottom: 1em;
	}

	h3,
	h4,
	h5,
	h6 {
		@include use-text-style('heading-150');

		margin-bottom: 1em;
		font-weight: 300;
	}
}

.content {
	line-height: 1.85714;

	p {
		@include use-text-style('type-100');

		font-weight: 300;

		&:not(:last-child) {
			margin-bottom: 1em;
		}
	}

	a {
		text-decoration: underline;
	}

	h2 {
		@include use-text-style('heading-400');
	}

	h3 {
		@include use-text-style('heading-200');
	}

	h4 {
		@include use-text-style('heading-180');
	}

	h5,
	h6 {
		@include use-text-style('heading-150');
	}

	&.hasMarginTop {
		h2,
		h3,
		h4,
		h5,
		h6,
		p {
			&:first-child {
				@include above('medium') {
					margin-top: 1em;
				}
			}
		}
	}

	h2,
	h3,
	h4,
	h5,
	h6 {
		@include font-family('primary');

		font-weight: 300;
		margin-bottom: 1em;

		.layer.__full & {
			text-align: center;
		}
	}
	/* stylelint-enable */

	:global(.line-separator) {
		display: block;
		width: 100%;
		height: 1px;
		content: '';
		background: color('primary-250');
	}

	:global(.underline) {
		text-decoration: underline;
	}
}

.ctaSection {
	margin: 3.5rem 0 0;
	text-align: center;
}
</style>
